#include <machine.h>
// #include <windows.h>
#include <stdlib.h>
#include <string.h>

#include <data.c>

ARRAY default_rslt  =	{		
			3,		// LENGTH + ZONES + BOUND
			SIMPLE,
			1,		// VECTOR
			APLLONG,
			0		// no elements
			};

#if	UNIX
#	define	_declspec(a)	// unix compiler's don't adulterate the language
#endif//UNIX

int add(void *lvp,void *rvp, void *rsltvp)
	{
	ARRAY *larg;
	ARRAY *rarg;
	ARRAY *rslt;
	BOUND b;

	aplint32  *lp,*rp,*rsltp;

	larg =  getA(lvp);
	rarg =  getA(rvp);

	putA(rsltvp,&default_rslt);

	if (larg->eltype != rarg->eltype)
		return EDOMAIN;
	if (larg->eltype != APLLONG)
		return EDOMAIN;
	if (larg->rank != rarg->rank)
		return RANK;
	if (larg->rank != 1)
		return RANK;
	if (larg->shape[0] != rarg->shape[0])
		return EDOMAIN;

	rslt = mkarray(APLLONG,1,larg->shape);

	if (rslt==0) return LIMIT;

	lp    = (aplint32 *)&larg->shape[1];
	rp    = (aplint32 *)&rarg->shape[1];
	rsltp = (aplint32 *)&rslt->shape[1];

	for (b=0;b<larg->shape[0];b++)
		*rsltp++=*lp+++*rp++;

	putA(rsltvp,rslt);

	return 0;
	}
